//---------------------------------------------------------------------------
#include <vcl.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <io.h>
#include <fcntl.h>
#include <sys\stat.h>



#pragma hdrstop

#include "Carbase.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
#include "Vehicle.cpp"
#include "Nastavenie.h"
#include "About.h"
#include "Prehlad.h"
#include "Triedenie.h"
#include "Zaradenie.h"
#include "Vyhladanie.h"

#define  DIVCHAR  ';'

void ChybaZapisu(Vehicle *Buff);
void ChybaFormatu(void);
int AddToFindTree(Vehicle *RootVertex,Vehicle *Vertex);

extern PACKAGE TfrmPrehlad *frmPrehlad;
extern PACKAGE TfrmTriedenie *frmTriedenie;
extern PACKAGE TfrmZaradenie *frmZaradenie;
extern PACKAGE TfrmFindVehicle *frmFindVehicle;

TCarMain *CarMain;
int DataFile;
int PocetVozidiel = 0, Poradie;
int SortKey = 0;                //Urcuje kluc pre triedenie
int Order = 0;                  //Urcuje tiredenie A-Z alebo Z-A
int Number = 100;               //Pocet zaznamov generovanych generatorom
int UserSet=0;                   //Priznak nastavenia uzivatelskej volby
int Zmena=0;
char Buffer[256];
char StrSet[5][256];
char CharSet[7];
char FileName[256]="Carbase.dat";
char SPZToFind[257];
AnsiString MenoSuboru;

Vehicle *FirstCar = NULL;
Vehicle *PreviousCar = NULL;
Vehicle *TopCar = NULL;
Vehicle *NextCar = NULL;
Vehicle *BinaryTreeRoot = NULL;



//---------------------------------------------------------------------------
__fastcall TCarMain::TCarMain(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------


void __fastcall TCarMain::FormCloseQuery(TObject *Sender, bool &CanClose)
{
   if(Application->MessageBox("Chce naozaj ukoi aplikciu??","Ukonenie CARBASE",
                              MB_YESNOCANCEL+MB_DEFBUTTON2+MB_ICONINFORMATION) == IDYES)
     CanClose = true;
   else
     CanClose = false;
}
//---------------------------------------------------------------------------


void __fastcall TCarMain::FormClose(TObject *Sender, TCloseAction &Action)
{
   //Vratime alokovanu pamet
   while(PocetVozidiel)
      {
         TopCar = FirstCar;
         for(int i=1;i < PocetVozidiel;i++)
            TopCar = TopCar->getNextVehicle();
         delete TopCar;
         PocetVozidiel--;
      }
//   FileClose(DataFile);
}
//---------------------------------------------------------------------------


void __fastcall TCarMain::KoniecClick(TObject *Sender)
{
   //Ukoncine aplikaciu
   CarMain->Close();
}
//---------------------------------------------------------------------------


void __fastcall TCarMain::OtvorSuborClick(TObject *Sender)
{
   if(PocetVozidiel && Zmena)
      if(Application->MessageBox("Otvorenm alieho prdte o vykonan zmeny. Pokraova?"\
                                 ,"Pozor!",MB_OKCANCEL+MB_ICONWARNING) == IDCANCEL)
        return;
   if(dlgOtvorSubor->Execute())
     {
        // Nacitanie dat z datoveho suboru

   int i, j;


   if(PocetVozidiel)
     {
        btNextCar->Enabled = false;
        btPrevCar->Enabled = false;
        ShellSort->Enabled = false;
        FindVehicle->Enabled = false;
        Poradie = 0;
        edSPZ->Clear();           //SPZ vozidla
        edTyp->Clear();           //Typ vozidla
        edZnacka->Clear();        //Znacka vozidla
        edFarba->Clear();         //Farba vozidla
        edMotorState->Clear();   //Stav Motora
        edChassisState->Clear();
        edInteriorState->Clear();
        edElBelongState->Clear();
        edGearboxState->Clear();
        edWheelsState->Clear();
        edCoolingState->Clear();
        mePrislus->Lines->Clear();
        edPoradie->Text = "0";              //Poradie zaznamu
        edPocVoz->Text = "0";            //Vypis poctu zaznamov
     }


   //Vratime alokovanu pamet ak uz mane nacitane data
   while(PocetVozidiel)
     {
        TopCar = FirstCar;
        for(int i=1;i < Poradie;i++)
           TopCar = TopCar->getNextVehicle();
        delete TopCar;
        PocetVozidiel--;
     }

   if(0 > (DataFile = FileOpen(MenoSuboru,fmOpenReadWrite)))
     {
        Application->MessageBox("Nepodarilo sa otvori sbor: ","Chyba!",\
                                MB_OK+MB_ICONERROR);
        return;
     }

   while(1)
     {
        //Citanie SPZ
        if(MAXSPZ != FileRead(DataFile, Buffer, MAXSPZ))
          {
             ChybaFormatu();
             return;
          }
        strcpy(StrSet[0], Buffer);
        if((!FileRead(DataFile, Buffer, 1)) || (Buffer[0] != ';'))
           {
             ChybaFormatu();
             return;
           }


        //Ideme citat typ vozidla
        j=0;
        do {
             if(!FileRead(DataFile, Buffer, 1))
               {
                  ChybaFormatu();
                  return;
               }
             StrSet[1][j]= Buffer[0];
        }while((Buffer[0] != DIVCHAR) && (Buffer[0] != '\n') && (j++ <= MAXTYPE));
        if(StrSet[1][j] != DIVCHAR)
          {
             ChybaFormatu();
             return;
          }
        StrSet[1][j] = '\0';

        //Ideme citat znacku vozidla
        j=0;
        do {
             if(!FileRead(DataFile, Buffer, 1))
               {
                  ChybaFormatu();
                  return;
               }
             StrSet[2][j]= Buffer[0];
        }while((Buffer[0] != DIVCHAR) && (Buffer[0] != '\n') && (j++ <= MAXTYPE));
        if(StrSet[2][j] != DIVCHAR)
          {
             ChybaFormatu();
             return;
          }
        StrSet[2][j] = '\0';


        //Ideme citat farbu vozidla
        j=0;
        do {
             if(!FileRead(DataFile, Buffer, 1))
               {
                  ChybaFormatu();
                  return;
               }
             StrSet[3][j]= Buffer[0];
        }while((Buffer[0] != DIVCHAR) && (Buffer[0] != '\n') && (j++ <= MAXTYPE));
        if(StrSet[3][j] != DIVCHAR)
          {
             ChybaFormatu();
             return;
          }
        StrSet[3][j] = '\0';


        //Nasleduje citanie stavov casti vozidla
        j=0;
        do {
              if((2 != FileRead(DataFile, Buffer, 2)) || (Buffer[0] < '1') || \
                 (Buffer[0] > '5') || (Buffer[1] != DIVCHAR) )
                 {
                   ChybaFormatu();
                   return;
                 }
              CharSet[j] = Buffer[0];
        }while(++j < 7);


        Buffer[0] = DIVCHAR;     //Pripravime sa na mozny koniec suboru


        //Na zaver nacitame este poznamku ak je
        if(FileRead(DataFile, Buffer,1) && (Buffer[0] != '\r'))
          {
            StrSet[4][0] = Buffer[0];
            j=1;
            do {
                  if(!FileRead(DataFile, Buffer, 1))
                    Buffer[0] = DIVCHAR;                //Koniec suboru
                  StrSet[4][j]= Buffer[0];
            }while((Buffer[0] != DIVCHAR) && (Buffer[0] != '\r') \
                   && (j++ <= MAXNOTE));
            if((StrSet[4][j] != '\r') && (StrSet[4][j] != DIVCHAR))
              {
                 ChybaFormatu();
                 return;
              }
            StrSet[4][j] = '\0';
          }
        else
            StrSet[4][0] = '\0';


        //Nacitali sme cely zaznam, ulozime ho do pamete a prejdeme na dalsi
        Vehicle *Car = new Vehicle();
        if(!PocetVozidiel)
          {
             FirstCar = Car;         //Smernik na prve vozidlo odlozime
             PreviousCar = Car;      //Inicializacia zoznamu
             BinaryTreeRoot = FirstCar;
          }
        PocetVozidiel++;
        Car->setVehicle(StrSet, CharSet);     //Ulozenie nacitanych dat
        Car->setIndex(PocetVozidiel);         //Nastavi index
        PreviousCar->setNextVehicle(Car);     //Zaradenie do zoznamu
        PreviousCar = Car;                    //Posun na dalsi zaznam

        //Zaroven s nacitavanim budeme vytvarat aj binarny vyhladavaci strom
        if( PocetVozidiel > 1 && (AddToFindTree(BinaryTreeRoot,Car) == 0))
           {
              Application->MessageBox("Sbor obsahuje zznamy s rovnakmi PZ.",\
                                      "Chyba!",MB_OK+MB_ICONERROR);
              PocetVozidiel--;
              delete Car;
              return;
           }

        //Teraz este pozrieme ci mame nieco v subore ak ano citame dalej
        if(Buffer[0] == DIVCHAR)
          {
             //Sme na konci suboru vypiseme prvy zaznam a koncime s citanim
             FirstCar->getVehicle(StrSet, CharSet);
             edSPZ->Text = StrSet[0];           //SPZ vozidla
             edTyp->Text = StrSet[1];           //Typ vozidla
             edZnacka->Text = StrSet[2];        //Znacka vozidla
             edFarba->Text = StrSet[3];         //Farba vozidla
             edMotorState->Text = CharSet[0];   //Stav Motora
             edChassisState->Text = CharSet[1];
             edInteriorState->Text = CharSet[2];
             edElBelongState->Text = CharSet[3];
             edGearboxState->Text = CharSet[4];
             edWheelsState->Text = CharSet[5];
             edCoolingState->Text = CharSet[6];
             AnsiString pom(StrSet[4]);
             mePrislus->Lines->Clear();
             mePrislus->Lines->Add(pom);          //Dalsie prislusenstvo
             edPoradie->Text = "1";              //Poradie zaznamu
             Poradie = 1;
             itoa(PocetVozidiel, StrSet[0], 10); //Prevod poctu zaznamov na text
             edPocVoz->Text = StrSet[0];            //Vypis poctu zaznamov
             btNextCar->Enabled = true;
             if(PocetVozidiel > 1)
               {
                  ShellSort->Enabled = true;
                  FindVehicle->Enabled = true;
               }
             TopCar = FirstCar;
             FileClose(DataFile);
             Zmena = 0;
             return;
          }

        //Ak nie sme na konci suboru presunieme sa na dalsi riadok a opet citame
        FileSeek(DataFile,1,1);
     }
   }  
}
//---------------------------------------------------------------------------


void __fastcall TCarMain::UlozSuborClick(TObject *Sender)
{
   if(PocetVozidiel)
     if(dlgUlozSubor->Execute())
       {
          Vehicle *Buff;
          char Character=DIVCHAR;

          prgPriebeh->Position = 0;
          prgPriebeh->Min = 0;
          prgPriebeh->Max = PocetVozidiel;
          Buff = TopCar;
          TopCar = FirstCar;
          if(0 > (DataFile=creat(MenoSuboru.c_str(),S_IWRITE)))
              {
                  Application->MessageBox("Chyba pri prci so sborom","Chyba!",\
                                   MB_OK+MB_ICONERROR);
                  return;
              }
          for(int i=0;i<PocetVozidiel;i++)
             {
                TopCar->getVehicle(StrSet,CharSet);
                for(int j=0;j<12;j++)
                   {
                      if(j<4)
                        if(StrLen(StrSet[j]) - write(DataFile,StrSet[j],StrLen(StrSet[j])))
                          ChybaZapisu(Buff);
                      if(j>3 && j!=11)
                        if(1 != write(DataFile,&(CharSet[j-4]),1))
                          ChybaZapisu(Buff);
                      if(j == 11)
                        if(StrLen(StrSet[4]) - write(DataFile,StrSet[4],StrLen(StrSet[4])))
                          ChybaZapisu(Buff);
                      if(j != 11)
                        if(1 != write(DataFile,&Character,1))
                           ChybaZapisu(Buff);
                   }
                TopCar = TopCar->getNextVehicle();
                if((i+1) < PocetVozidiel)
                  if(1 != write(DataFile,"\n",1))
                    ChybaZapisu(Buff);
                prgPriebeh->Position++;
             }
          close(DataFile);
          Zmena = 0;
          prgPriebeh->Position=0;
       }
   if(!PocetVozidiel)
     Application->MessageBox("Nie s natan iadne dta","Info",\
                              MB_OK+MB_ICONINFORMATION);
}
//---------------------------------------------------------------------------


void __fastcall TCarMain::VseobClick(TObject *Sender)
{
   frmNastavenie->ShowModal();
}
//---------------------------------------------------------------------------


void __fastcall TCarMain::dlgOtvorSuborCanClose(TObject *Sender,
      bool &CanClose)
{
   MenoSuboru = dlgOtvorSubor->FileName;
}
//---------------------------------------------------------------------------


void __fastcall TCarMain::dlgUlozSuborCanClose(TObject *Sender,
      bool &CanClose)
{
   MenoSuboru = dlgUlozSubor->FileName;
   CanClose = true;
}
//---------------------------------------------------------------------------




void __fastcall TCarMain::btNextCarClick(TObject *Sender)
{

// obsluha buttonu "Nasledujuci zaznam >>"

   TopCar = TopCar->getNextVehicle();        //Prejde na dalsi zaznam
   Poradie++;

   //Osetrenie buttonov
   if(Poradie == PocetVozidiel)
     btNextCar->Enabled = false;
   if(Poradie == 2)
     btPrevCar->Enabled = true;

   //Vypis zo zaznamu
   TopCar->getVehicle(StrSet, CharSet);
   edSPZ->Text = StrSet[0];             //SPZ vozidla
   edTyp->Text = StrSet[1];             //Typ vozidla
   edZnacka->Text = StrSet[2];          //Znacka vozidla
   edFarba->Text = StrSet[3];           //Farba vozidla
   edMotorState->Text = CharSet[0];     //Stav Motora
   edChassisState->Text = CharSet[1];   //Stav podvozku
   edInteriorState->Text = CharSet[2];  //Stav interieru
   edElBelongState->Text = CharSet[3];  //Stav le. prislusenstva
   edGearboxState->Text = CharSet[4];   //Stav prevodovky
   edWheelsState->Text = CharSet[5];    //Stav kolies
   edCoolingState->Text = CharSet[6];   //Stav chladenia
   mePrislus->Lines->Clear();
   AnsiString pom(StrSet[4]);
   mePrislus->Lines->Add(pom);          //Dalsie prislusenstvo
   itoa(Poradie, StrSet[0], 10);        //Prevod poctu zaznamov na text
   edPoradie->Text = StrSet[0];         //Vypis poradia zaznamu
}
//---------------------------------------------------------------------------

void __fastcall TCarMain::btPrevCarClick(TObject *Sender)
{
// obsluha buttonu "<< Predchadzajuci zaznam"

   Poradie--;
   TopCar = FirstCar;
   for(int i=1;i<Poradie;i++)
      TopCar = TopCar->getNextVehicle();     //Vyhlada ziadanu poziciu

   //Osetrenie buttonov
   if((Poradie+1) == PocetVozidiel)
      btNextCar->Enabled = true;
   if(Poradie == 1)
      btPrevCar->Enabled = false;

   //Vypus zo zaznamu
   TopCar->getVehicle(StrSet, CharSet);
   edSPZ->Text = StrSet[0];             //SPZ vozidla
   edTyp->Text = StrSet[1];             //Typ vozidla
   edZnacka->Text = StrSet[2];          //Znacka vozidla
   edFarba->Text = StrSet[3];           //Farba vozidla
   edMotorState->Text = CharSet[0];     //Stav Motora
   edChassisState->Text = CharSet[1];   //Stav podvozku
   edInteriorState->Text = CharSet[2];  //Stav interieru
   edElBelongState->Text = CharSet[3];  //Stav le. prislusenstva
   edGearboxState->Text = CharSet[4];   //Stav prevodovky
   edWheelsState->Text = CharSet[5];    //Stav kolies
   edCoolingState->Text = CharSet[6];   //Stav chladenia
   mePrislus->Lines->Clear();
   AnsiString pom(StrSet[4]);
   mePrislus->Lines->Add(pom);          //Dalsie prislusenstvo
   itoa(Poradie, StrSet[0], 10);        //Prevod poctu zaznamov na text
   edPoradie->Text = StrSet[0];         //Vypis poradia zaznamu
}
//---------------------------------------------------------------------------

void __fastcall TCarMain::GendataClick(TObject *Sender)
{

// Tento blok generuje fiktivne data a ulozi ich do suboru

  int i, j;
  char Character;
  FILE *DataFile=NULL;

  prgPriebeh->Position = 0;
  prgPriebeh->Min = 0;
  prgPriebeh->Max = Number;

  randomize();
  if((DataFile=fopen(FileName,"wt")) == NULL)
    {
       Application->MessageBox("Pozor! Dtov sbor sa nepodrilo otvori!" ,"Chyba",\
                           MB_OK+MB_ICONERROR);
       return;
    }


  for(i=1;i <= Number;i++)
     {
        //Generujeme SPZ auta
	for(j=0;j<2;j++)
	    {
	       Character=random(26)+'A';     //Generuje velke pismena pre SPZ
	       fputc(Character,DataFile);
	    }
	fputc('-',DataFile);
	for(j=0;j<3;j++)
	   {
              Character=random(10)+'0';     //Generuje cilsa pre SPZ
	      fputc(Character,DataFile);
	   }
	for(j=0;j<2;j++)
	   {
	      Character=random(26)+'A';     //Generuje velke pismena pre SPZ
	      fputc(Character,DataFile);
           }
        fputc(DIVCHAR,DataFile);

        //Generujeme typ auta
        switch(random(3))
           {
        	case 0: fprintf(DataFile,"%s","osobne");
                        break;
        	case 1: fprintf(DataFile,"%s","nakladne");
        		break;
        	case 2: fprintf(DataFile,"%s","uzitkove");
	        	break;
           }
        fputc(DIVCHAR,DataFile);

        //Generujeme znacku auta
        switch(random(18))
           {
	      case 0: fprintf(DataFile,"%s","BMW");
                      break;
	      case 1: fprintf(DataFile,"%s","AUDI");
		      break;
	      case 2: fprintf(DataFile,"%s","VOLKSWAGEN");
	              break;
              case 3: fprintf(DataFile,"%s","SKODA");
		      break;
	      case 4: fprintf(DataFile,"%s","HONDA");
		      break;
	      case 5: fprintf(DataFile,"%s","VOLVO");
		      break;
              case 6: fprintf(DataFile,"%s","MITSIBISHI");
		      break;
	      case 7: fprintf(DataFile,"%s","TOYOTA");
		      break;
	      case 8: fprintf(DataFile,"%s","ISUZU");
		      break;
	      case 9: fprintf(DataFile,"%s","TATRA");
		      break;
	      case 10: fprintf(DataFile,"%s","KAMAZ");
		       break;
	      case 11: fprintf(DataFile,"%s","KENWORTH");
		       break;
	      case 12: fprintf(DataFile,"%s","GMC");
		       break;
	      case 13: fprintf(DataFile,"%s","FORD");
		       break;
	      case 14: fprintf(DataFile,"%s","LAMBORGINI");
		       break;
	      case 15: fprintf(DataFile,"%s","MASSERATTI");
		       break;
	      case 16: fprintf(DataFile,"%s","ASTON MARTIN");
		       break;
	      case 17: fprintf(DataFile,"%s","JAGUAR");
		       break;

           }
        fputc(DIVCHAR,DataFile);

        //Generujeme farbu auta
        switch(random(18))
           {
	      case 0: fprintf(DataFile,"%s","cervena");
		      break;
	      case 1: fprintf(DataFile,"%s","biela");
		      break;
	      case 2: fprintf(DataFile,"%s","modra");
		      break;
	      case 3: fprintf(DataFile,"%s","cierna");
		      break;
	      case 4: fprintf(DataFile,"%s","fialova");
		      break;
	      case 5: fprintf(DataFile,"%s","zelena");
		      break;
	      case 6: fprintf(DataFile,"%s","siva");
		      break;
	      case 7: fprintf(DataFile,"%s","zlta");
		      break;
	      case 8: fprintf(DataFile,"%s","hneda");
		      break;
	      case 9: fprintf(DataFile,"%s","strieborna metal.");
		      break;
              case 10: fprintf(DataFile,"%s","cierna metal.");
	               break;
	      case 11: fprintf(DataFile,"%s","zlata metal.");
		      break;
	      case 12: fprintf(DataFile,"%s","hneda matel.");
		       break;
	      case 13: fprintf(DataFile,"%s","modra metal.");
		       break;
	      case 14: fprintf(DataFile,"%s","siva metal.");
		       break;
	      case 15: fprintf(DataFile,"%s","zelena metal.");
		       break;
	      case 16: fprintf(DataFile,"%s","bordova");
		       break;
	      case 17: fprintf(DataFile,"%s","bordova metal.");
		       break;
           }
        fputc(DIVCHAR,DataFile);

        //Generujeme stav motora, podvozku, interieru, el. prislus., provodovky,
        //kolies, chladenia.
        fputc(random(5)+'0'+1,DataFile);   //MotorState
        fputc(DIVCHAR,DataFile);

        fputc(random(5)+'0'+1,DataFile);   //ChassisState
        fputc(DIVCHAR,DataFile);

        fputc(random(5)+'0'+1,DataFile);   //InteriorState
        fputc(DIVCHAR,DataFile);

        fputc(random(5)+'0'+1,DataFile);   //ElBelongState
        fputc(DIVCHAR,DataFile);

        fputc(random(5)+'0'+1,DataFile);   //GearBoxState
        fputc(DIVCHAR,DataFile);

        fputc(random(5)+'0'+1,DataFile);   //WheelState
        fputc(DIVCHAR,DataFile);

        fputc(random(5)+'0'+1,DataFile);   //CoolingState
        fputc(DIVCHAR,DataFile);

        //Generujeme poznamku o prislusenstve auta
        switch(random(18))
           {
	      case 1: fprintf(DataFile,"%s","klimatizacia");
		      fprintf(DataFile,"%s",", ");
	      case 2: fprintf(DataFile,"%s","ABS");
		      fprintf(DataFile,"%s",", ");
	      case 3: fprintf(DataFile,"%s","ESP");
		      fprintf(DataFile,"%s",", ");
	      case 4: fprintf(DataFile,"%s","el. stahovanie okien");
		      fprintf(DataFile,"%s",", ");
              case 5: fprintf(DataFile,"%s","2x airbag");
		      fprintf(DataFile,"%s",", ");
	      case 6: fprintf(DataFile,"%s","palubny pocitac");
		      fprintf(DataFile,"%s",", ");
	      case 7: fprintf(DataFile,"%s","GPS");
		      fprintf(DataFile,"%s",", ");
	      case 8: fprintf(DataFile,"%s","autoradio");
		      fprintf(DataFile,"%s",", ");
	      case 9: fprintf(DataFile,"%s","ostrek svetlometov");
		      fprintf(DataFile,"%s",", ");
	      case 10: fprintf(DataFile,"%s","drziak minci");
		      fprintf(DataFile,"%s",", ");
	      case 11: fprintf(DataFile,"%s","tretie brzdove svetlo");
		       fprintf(DataFile,"%s",", ");
	      case 12: fprintf(DataFile,"%s","stresne okno");
		       fprintf(DataFile,"%s",", ");
	      case 13: fprintf(DataFile,"%s","hmlove svetla");
		       fprintf(DataFile,"%s",", ");
	      case 14: fprintf(DataFile,"%s","central");
		       fprintf(DataFile,"%s",", ");
	      case 15: fprintf(DataFile,"%s","imobilizer");
		       fprintf(DataFile,"%s",", ");
	      case 16: fprintf(DataFile,"%s","zapalovac");
                       fprintf(DataFile,"%s",", ");
	      case 17: fprintf(DataFile,"%s","potahy");
	      case 0: break;
           }
        if(i != Number)
	  fprintf(DataFile,"%s","\n");
        prgPriebeh->Position++;
     }
   if(fclose(DataFile) == EOF)
     Application->MessageBox("Dta boli vygenerovan ale sbor sa nepodarilo zatvori!","Chyba",\
                           MB_OK+MB_ICONERROR);
   else
     Application->MessageBox("Dta boli spene vygenerovan","Info",\
                           MB_OK+MB_ICONINFORMATION);
   prgPriebeh->Position = 0;
}
//---------------------------------------------------------------------------


void __fastcall TCarMain::ShellSortClick(TObject *Sender)
{
//Tato cast kodu je volana pri kliknuti na polozku "Triedenie" v roletovom
//menu "Nastroje". Jeho ulohou je zotriedit polozky jednosmerneho spojkoveho
//zoznamu abecedne podla algoritmum "Shell sort"
// Vyznam premennych:
// Vymena - idikuje vymena poloziek medzi sebou
// TopCar - smernik na prvu porovnanvanu polozku
// PreviousCar - smernik na polozku, ktora predchadza prvu porovnanvanu polozku
// TopCar1 - smernik na druhu porovnanvanu polozku
// PreviousCar - smernik na polozku, ktora predchadza druhu porovnanvanu polozku
// Pocet - Udava o kolko je prva porovnavana polozka vzdialena od druhej


   int Vymena=0, Vymen=0, Pocet=PocetVozidiel, i, j;
   char StrSet1[5][256], CharSet1[7];
   Vehicle *TopCar1 = TopCar = FirstCar, *Buff, *PreviousCar1;

   prgPriebeh->Position = 0;
   prgPriebeh->Min = 0;
   prgPriebeh->Max = 0;

   do {
         Pocet = (Pocet+1)/2;
         prgPriebeh->Max++;
      }while(Pocet > 2);

   Pocet = PocetVozidiel;
   do {
         //Vypocet vzdialenosti druheho prvku
         Pocet = (Pocet+1)/2;

         //Nasledujuci cylkus do {} while budeme vykonavat kym sa
         //v porovnavacom cykle bude diat vymena
         do {
               //Najprv sa nastavime na prvy prvok v zozname
               PreviousCar = TopCar = TopCar1 = FirstCar;

               //Tento cyklus vyhlada druhy prvok, ktory je od prveho prvku
               // vzdialeny o Pocet zaznamov
               for(i=1;i<Pocet;i++)
                  {
                     PreviousCar1 = TopCar1;
                     TopCar1 = TopCar1->getNextVehicle();
                  }

               //Inicializujeme indikator vymeny, ktory kontrolujeme na konci
               Vymena = 0;

               //Nasleduje porovnavaci cyklus
               for(i=Pocet;i<=PocetVozidiel;i++)
                  {
                    //Zvolime typ triedenia: ak Order == 0 => A-Z
                    //ak Order != 0 => Z-A
                    if(!Order)
                      {
                         //Triedenie A-Z
                         TopCar->getVehicle(StrSet, CharSet);
                         TopCar1->getVehicle(StrSet1, CharSet1);
                      }
                    else
                      {
                         //Triedenie A-Z
                         TopCar->getVehicle(StrSet1, CharSet1);
                         TopCar1->getVehicle(StrSet, CharSet);
                      }
                    //V nasledujucich dvoch if-och sa realizuje triedenie podla zvoleneho kluca
                    if((SortKey < 4) && (0 < strcmp(StrSet[SortKey], StrSet1[SortKey])))
                       Vymen = 1;
                    if((SortKey > 3) && (CharSet[SortKey-4] > CharSet1[SortKey-4]))
                       Vymen = 1;

                    //Ak je to nutne polozky sa vymenia
                    if(Vymen)
                      {
                         Zmena = 1;
                         Vymena = 1;
                         Vymen = 0;
                         //Pozor ak vymiename prvky vedla seba musime postupovat
                         //Tak ako je to v nasledujucom bloku if. Inac obdrzime jedinu
                         //polozku zoznamu, ktora ukazuje sama na seba a navyse
                         //stratime pristup k ostatnym polozkam
                         if( Pocet == 2)
                           {
                              if(TopCar == FirstCar)
                                {
                                   TopCar->setNextVehicle(TopCar1->getNextVehicle());
                                   TopCar1->setNextVehicle(FirstCar);
                                   FirstCar = TopCar1;
                                }
                              else
                                {
                                   Buff = TopCar->getNextVehicle();
                                   TopCar->setNextVehicle(TopCar1->getNextVehicle());
                                   PreviousCar->setNextVehicle(Buff);
                                   TopCar1->setNextVehicle(TopCar);
                                }
                           }

                         //V nasledujucom bloku else prehadzujeme polozky vtedy
                         //ak nie su susedne. Teda pomocou tohto blok sa bude vykonavat
                         //prehodenie poloziek vzdy ked bude Pocet > 2
                         else
                           {
                              Buff = TopCar1->getNextVehicle();
                              TopCar1->setNextVehicle(TopCar->getNextVehicle());
                              TopCar->setNextVehicle(Buff);

                              if(TopCar == FirstCar)
                                {
                                   PreviousCar1->setNextVehicle(TopCar);
                                   FirstCar = TopCar1;
                                }
                              else
                                {
                                   Buff = PreviousCar->getNextVehicle();
                                   PreviousCar->setNextVehicle(PreviousCar1->getNextVehicle());
                                   PreviousCar1->setNextVehicle(Buff);
                                }
                           }
                         Buff = TopCar;
                         TopCar = TopCar1;
                         TopCar1 = Buff;
                         //Prehodenie indexov
                         j = TopCar->getIndex();
                         TopCar->setIndex(TopCar1->getIndex());
                         TopCar1->setIndex(j);
                      }
                    //Tu sa presunieme na nasledujuce polozky
                    PreviousCar = TopCar;
                    TopCar = TopCar->getNextVehicle();
                    PreviousCar1 = TopCar1;
                    TopCar1 = TopCar1->getNextVehicle();
                  }
             //Nalsdeduje kontrola ci pri predchadzajucom prechode nastala vymena
             //prvkov. Ak ano zopakujeme prechod zoznamom pri nezmenenj vzdialenosti
             //prveo a druheho prvku
            }while(Vymena);

        //Pri predchadzajucom prechode zoznamom nenastala vymena.
        //Tym padom zkontrolujeme podmienku pre vzdialenost danu premennou Pocet.
        //Ak vyhovuje skocime na zaciatok cyklu zmenime vzdialenost na polovicu
        //a opet pojdeme porovnavat
          prgPriebeh->Position++;
       }while(Pocet > 2);

   //Vypis zo zaznamu
   TopCar = FirstCar;
   FirstCar->getVehicle(StrSet, CharSet);
   edSPZ->Text = StrSet[0];             //SPZ vozidla
   edTyp->Text = StrSet[1];             //Typ vozidla
   edZnacka->Text = StrSet[2];          //Znacka vozidla
   edFarba->Text = StrSet[3];           //Farba vozidla
   edMotorState->Text = CharSet[0];     //Stav Motora
   edChassisState->Text = CharSet[1];   //Stav podvozku
   edInteriorState->Text = CharSet[2];  //Stav interieru
   edElBelongState->Text = CharSet[3];  //Stav le. prislusenstva
   edGearboxState->Text = CharSet[4];   //Stav prevodovky
   edWheelsState->Text = CharSet[5];    //Stav kolies
   edCoolingState->Text = CharSet[6];   //Stav chladenia
   mePrislus->Lines->Clear();
   AnsiString pom(StrSet[4]);
   mePrislus->Lines->Add(pom);          //Dalsie prislusenstvo
   edPoradie->Text = "1";         //Vypis poradia zaznamu
   Poradie = 1;
   btNextCar->Enabled = true;
   btPrevCar->Enabled = false;
   Application->MessageBox("Dta boli spene zotrieden","Info",\
                           MB_OK+MB_ICONINFORMATION);
   prgPriebeh->Position = 0;
}
//---------------------------------------------------------------------------



void __fastcall TCarMain::AboutClick(TObject *Sender)
{
   frmAbout->ShowModal();
}
//---------------------------------------------------------------------------


void __fastcall TCarMain::PreviewClick(TObject *Sender)
{
   Application->CreateForm(__classid(TfrmPrehlad), &frmPrehlad);
   frmPrehlad->ShowModal();
   delete frmPrehlad;
}
//---------------------------------------------------------------------------


void ChybaZapisu(Vehicle *Buff)
{


   Application->MessageBox("Chyba pri zpise do sboru","Chyba!",\
                           MB_OK+MB_ICONERROR);
   FileClose(DataFile);
   TopCar = Buff;

}
//---------------------------------------------------------------------------


void ChybaFormatu(void)
{
   Vehicle *Top;


   while(PocetVozidiel)
      {
         Top = FirstCar;
         for(int i=1;i<PocetVozidiel;i++)
            Top = Top->getNextVehicle();
         delete Top;
         PocetVozidiel--;
       }
   FileClose(DataFile);
   Application->MessageBox("Nesprvny formt sboru","Chyba!",
                            MB_OK+MB_ICONERROR);
}
//---------------------------------------------------------------------------
void __fastcall TCarMain::AddCarClick(TObject *Sender)
{
   frmZaradenie->ShowModal();
   if(PocetVozidiel)
     {
        int Size = StrLen(edPocVoz->Text.c_str());
        Size++;                                   //Add room for null character
        char Buffer[256];
        edPocVoz->GetTextBuf(Buffer,Size);     //Insert Text into the StrSet[0]
        if(PocetVozidiel != atoi(Buffer))
          {
            itoa(PocetVozidiel,Buffer,10);
            edPocVoz->Text = Buffer;

            //V Nasledujucych krokoch pridame index a zaradime do bin. vyhlad. stromu
            Vehicle *Car = FirstCar;
            if(PocetVozidiel == 1)
              BinaryTreeRoot = FirstCar; 
            for(int i=1;i<PocetVozidiel;i++)
               Car = Car->getNextVehicle();
            Car->setIndex(PocetVozidiel);
            if(0 == AddToFindTree(BinaryTreeRoot,Car) && PocetVozidiel > 1)
              {
                 Application->MessageBox("Sbor obsahuje zznamy s rovnakmi PZ.",\
                                      "Chyba!",MB_OK+MB_ICONERROR);
                 PocetVozidiel--;
                 delete Car;
                 return;
              }
          }


        if(PocetVozidiel > 1)
          {
             btNextCar->Enabled = true;
             ShellSort->Enabled = true;
             FindVehicle->Enabled = true;
          }
        else
          {
             //Tu ideme ak pred pridanim bol pocet zaznamov rovny nule
             FirstCar->getVehicle(StrSet, CharSet);
             edSPZ->Text = StrSet[0];             //SPZ vozidla
             edTyp->Text = StrSet[1];             //Typ vozidla
             edZnacka->Text = StrSet[2];          //Znacka vozidla
             edFarba->Text = StrSet[3];           //Farba vozidla
             edMotorState->Text = CharSet[0];     //Stav Motora
             edChassisState->Text = CharSet[1];   //Stav podvozku
             edInteriorState->Text = CharSet[2];  //Stav interieru
             edElBelongState->Text = CharSet[3];  //Stav le. prislusenstva
             edGearboxState->Text = CharSet[4];   //Stav prevodovky
             edWheelsState->Text = CharSet[5];    //Stav kolies
             edCoolingState->Text = CharSet[6];   //Stav chladenia
             mePrislus->Lines->Clear();
             AnsiString pom(StrSet[4]);
             mePrislus->Lines->Add(pom);          //Dalsie prislusenstvo
             edPoradie->Text = "1";         //Vypis poradia zaznamu
             Poradie = 1;
          }
     }
}
//---------------------------------------------------------------------------
int AddToFindTree(Vehicle *RootVertex,Vehicle *Vertex)
{
 //Tato funkcia vykona zaradenie zaznamu do binarneho vyhladavacieho stromu

   char RootSPZ[257], SPZ[257];
   int CmpString;
   Vehicle *Buffer;

   Vertex->getSPZ(SPZ);         //Nacitame SPZ zaradovaneho
   while(1)
     {
        //Na zaciatku cyklu obsahuje RootVertex smernik na koren stromu
        //Po kazdom dalsom prechode sa do RootVertex presunie smernik na pravy,
        //alebo lavy podstrom ak exituje. Ak neexistuje zaznam, ktoreho smernik
        //je vo Vertex sa zaradi na dane miesto a program konci s navratovou
        //hodnotou 1.
        RootVertex->getSPZ(RootSPZ);
        if((CmpString=strcmp(RootSPZ,SPZ)) == 0)
          return(0);       //Pozor! Rovnake zaznamy => vrati 0.

        if( 0 > CmpString)
          //RootSPZ < SPZ => Ideme do praveho podstromu
          if(RootVertex->getRightSon() == NULL)
            {
               //RootVertex nema praveho syna => zaradime Vertex
               RootVertex->setRightSon(Vertex);
               return 1;
            }
          else
            {
               //Ma praveho syna => prejdeme do praveho podstromu a
               //pokracujeme dalsou iteraciou.
               RootVertex = RootVertex->getRightSon();
               continue;
            }

        if( 0 < CmpString)
          //RootSPZ > SPZ => Ideme do laveho podstromu
          if(RootVertex->getLeftSon() == NULL)
            {
               //RootVertex nema laveho syna  => zaradime Vertex
               RootVertex->setLeftSon(Vertex);
               return 1;
            }
          else
            {
               //Ma laveho syna => prejdeme do laveho podstromu a
               //pokracujeme dalsou iteraciou.
               RootVertex = RootVertex->getLeftSon();
               continue;
            }
     }
}
//---------------------------------------------------------------------------

void __fastcall TCarMain::FindVehicleClick(TObject *Sender)
{
 //Vyhladanie daneho zaznamu podla SPZ v binarm\nom vyhladavacom strome

   char SPZ[257];
   int CmpString;
   Vehicle *Vertex = BinaryTreeRoot;

   frmFindVehicle->ShowModal();
   if(SPZToFind[0] == '\0')
     return;

   while(1)
     {
        Vertex->getSPZ(SPZ);
        if((CmpString=strcmp(SPZ,SPZToFind)) == 0)
          {
             //Nasli sme pozadovany zaznam tak ho zobrazime
             Vertex->getVehicle(StrSet, CharSet);
             edSPZ->Text = StrSet[0];             //SPZ vozidla
             edTyp->Text = StrSet[1];             //Typ vozidla
             edZnacka->Text = StrSet[2];          //Znacka vozidla
             edFarba->Text = StrSet[3];           //Farba vozidla
             edMotorState->Text = CharSet[0];     //Stav Motora
             edChassisState->Text = CharSet[1];   //Stav podvozku
             edInteriorState->Text = CharSet[2];  //Stav interieru
             edElBelongState->Text = CharSet[3];  //Stav le. prislusenstva
             edGearboxState->Text = CharSet[4];   //Stav prevodovky
             edWheelsState->Text = CharSet[5];    //Stav kolies
             edCoolingState->Text = CharSet[6];   //Stav chladenia
             mePrislus->Lines->Clear();
             AnsiString pom(StrSet[4]);
             mePrislus->Lines->Add(pom);          //Dalsie prislusenstvo
             itoa(Vertex->getIndex(),StrSet[4],10);
             edPoradie->Text = StrSet[4];         //Vypis poradia zaznamu
             Poradie = Vertex->getIndex();
             if(Poradie == 1)
               {
                  btNextCar->Enabled = true;
                  btPrevCar->Enabled = false;
               }
             if(Poradie == PocetVozidiel)
               {
                  btNextCar->Enabled = false;
                  btPrevCar->Enabled = true;
               }
             if(Poradie > 1 && Poradie < PocetVozidiel)
               {
                  btNextCar->Enabled = true;
                  btPrevCar->Enabled = true;
               }

             return;
          }

        if( 0 > CmpString)
          //SPZ < SPZToFind => Ideme do praveho podstromu
          if(Vertex->getRightSon() == NULL)
            {
               //Nema praveho syna => nemame taky zaznam
               Application->MessageBox("Vozidlo nie je evidovane!","Info",
                            MB_OK+MB_ICONINFORMATION);
               return;
            }
          else
            {
               //Ma praveho syna => prejdeme do praveho podstromu a
               //pokracujeme dalsou iteraciou.
               Vertex = Vertex->getRightSon();
               continue;
            }

        if( 0 < CmpString)
          //SPZ > SPZToFind => Ideme do laveho podstromu
          if(Vertex->getLeftSon() == NULL)
            {
               //Nema laveho syna => nemame taky zaznam
               Application->MessageBox("Vozidlo nie je evidovane!","Info",
                            MB_OK+MB_ICONINFORMATION);
               return;
            }
          else
            {
               //Ma laveho syna => prejdeme do laveho podstromu a
               //pokracujeme dalsou iteraciou.
               Vertex = Vertex->getLeftSon();
               continue;
            }
     }

}
//---------------------------------------------------------------------------

