//---------------------------------------------------------------------------

#include <vcl.h>
#include <string.h>
#pragma hdrstop

#include "Zaradenie.h"
#include "Vehicle.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"

int CheckOutSPZ(TEdit *edSPZAdd, TButton *Button);
int CheckOutStav(TEdit *edStav);
int CheckOutBelong(TMemo *mePrislus);

extern Vehicle *FirstCar;
extern Vehicle *TopCar;
extern int PocetVozidiel;
extern int Zmena;


TfrmZaradenie *frmZaradenie;
//---------------------------------------------------------------------------
__fastcall TfrmZaradenie::TfrmZaradenie(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TfrmZaradenie::FormShow(TObject *Sender)
{
   edSPZAdd->Clear();
   edSPZAdd->SetFocus();
   edTypAdd->Clear();
   edZnackaAdd->Clear();
   edFarbaAdd->Clear();
   edMotorStateAdd->Clear();
   edChassisStateAdd->Clear();
   edInteriorStateAdd->Clear();
   edElBelongStateAdd->Clear();
   edGearboxStateAdd->Clear();
   edWheelsStateAdd->Clear();
   edCoolingStateAdd->Clear();
   mePrislusAdd->Clear();
}
//---------------------------------------------------------------------------
void __fastcall TfrmZaradenie::btnAddCarOKClick(TObject *Sender)
{

   char StrSet[5][256];
   char CharSet[7];

   //Nacitanie SPZ vozidla
   if(!CheckOutSPZ(edSPZAdd,btnAddCarOK))
     return;
   int Size = StrLen(edSPZAdd->Text.c_str());
   Size++;                                   //Add room for null character
   edSPZAdd->GetTextBuf(StrSet[0],Size);     //Insert Text into the StrSet[0]

   //Nacitame typ vozidla
   Size = StrLen(edTypAdd->Text.c_str());
   Size++;                                   //Add room for null character
   edTypAdd->GetTextBuf(StrSet[1],Size);     //Insert Text into the StrSet[1]

   //Nacitame znacku vozidla
   Size = StrLen(edZnackaAdd->Text.c_str());
   Size++;                                   //Add room for null character
   edZnackaAdd->GetTextBuf(StrSet[2],Size);  //Insert Text into the StrSet[2]

   //Nacitame farbu vozidla
   Size = StrLen(edFarbaAdd->Text.c_str());
   Size++;                                   //Add room for null character
   edFarbaAdd->GetTextBuf(StrSet[3],Size);   //Insert Text into the StrSet[3]


   //Macitanie stavu casti vozidla
   if(!CheckOutStav(edMotorStateAdd))
     return;
   CharSet[0] = *(edMotorStateAdd->Text.c_str());

   if(!CheckOutStav(edChassisStateAdd))
     return;
   CharSet[1] = *(edChassisStateAdd->Text.c_str());

   if(!CheckOutStav(edInteriorStateAdd))
     return;
   CharSet[2] = *(edInteriorStateAdd->Text.c_str());

   if(!CheckOutStav(edElBelongStateAdd))
     return;
   CharSet[3] = *(edElBelongStateAdd->Text.c_str());

   if(!CheckOutStav(edGearboxStateAdd))
     return;
   CharSet[4] = *(edGearboxStateAdd->Text.c_str());

   if(!CheckOutStav(edWheelsStateAdd))
     return;
   CharSet[5] = *(edWheelsStateAdd->Text.c_str());

   if(!CheckOutStav(edCoolingStateAdd))
     return;
   CharSet[6] = *(edCoolingStateAdd->Text.c_str());

   //Nacitanie poznamky o vybave vozidla
   if(!CheckOutBelong(mePrislusAdd))
     return;
   strcpy(StrSet[4],mePrislusAdd->Lines->GetText());


   Vehicle *Car = FirstCar;
   if(PocetVozidiel)
     {
        //Vyhladanie konca zoznamu
        for(int i=1; i<PocetVozidiel; i++)
           Car = Car->getNextVehicle();

        //Zaradenie zaznamu na koniec zoznamu
        Car->setNextVehicle(new Vehicle);
        Car = Car->getNextVehicle();
     }
   else
        Car = TopCar = FirstCar = new Vehicle;

   Car->setVehicle(StrSet,CharSet);
   PocetVozidiel++;
   Zmena = 1;
   frmZaradenie->Close();
}
//---------------------------------------------------------------------------
void __fastcall TfrmZaradenie::btnAddCarStornoClick(TObject *Sender)
{
 // Click on Storno button

   frmZaradenie->Close();
}
//---------------------------------------------------------------------------
void __fastcall TfrmZaradenie::edSPZAddExit(TObject *Sender)
{
//Pri opusteni editacneho pola SPZ

   if(btnAddCarStorno->Focused())
     return;
   CheckOutSPZ(edSPZAdd,btnAddCarOK);
}
//---------------------------------------------------------------------------
void __fastcall TfrmZaradenie::edSPZAddChange(TObject *Sender)
{
//Ak sa zaplni editacne pole SPZ prejde na editacne pole Typ

    if(StrLen(edSPZAdd->Text.c_str()) == MAXSPZ)
      edTypAdd->SetFocus();
}
//---------------------------------------------------------------------------
void __fastcall TfrmZaradenie::edTypAddChange(TObject *Sender)
{
//Ak sa zaplni editacne pole Typ prejde na editacne pole Znacka

    if(StrLen(edTypAdd->Text.c_str()) == MAXTYPE)
      edZnackaAdd->SetFocus();
}
//---------------------------------------------------------------------------

void __fastcall TfrmZaradenie::edZnackaAddChange(TObject *Sender)
{
//Ak sa zaplni editacne pole Znacka prejde na editacne pole Fraba

    if(StrLen(edZnackaAdd->Text.c_str()) == MAXMARK)
      edFarbaAdd->SetFocus();
}
//---------------------------------------------------------------------------

void __fastcall TfrmZaradenie::edFarbaAddChange(TObject *Sender)
{
//Ak sa zaplni editacne pole Farba prejde na editacne pole Stav motora

    if(StrLen(edFarbaAdd->Text.c_str()) == MAXCOLOUR)
      edMotorStateAdd->SetFocus();
}
//---------------------------------------------------------------------------

void __fastcall TfrmZaradenie::edMotorStateAddChange(TObject *Sender)
{
    if(StrLen(edMotorStateAdd->Text.c_str()) == 1)
      edChassisStateAdd->SetFocus();
}
//---------------------------------------------------------------------------

void __fastcall TfrmZaradenie::edChassisStateAddChange(TObject *Sender)
{
    if(StrLen(edChassisStateAdd->Text.c_str()) == 1)
      edInteriorStateAdd->SetFocus();
}
//---------------------------------------------------------------------------

void __fastcall TfrmZaradenie::edInteriorStateAddChange(TObject *Sender)
{
    if(StrLen(edInteriorStateAdd->Text.c_str()) == 1)
      edElBelongStateAdd->SetFocus();
}
//---------------------------------------------------------------------------

void __fastcall TfrmZaradenie::edElBelongStateAddChange(TObject *Sender)
{
    if(StrLen(edElBelongStateAdd->Text.c_str()) == 1)
      edGearboxStateAdd->SetFocus();
}
//---------------------------------------------------------------------------

void __fastcall TfrmZaradenie::edGearboxStateAddChange(TObject *Sender)
{
    if(StrLen(edGearboxStateAdd->Text.c_str()) == 1)
      edWheelsStateAdd->SetFocus();
}
//---------------------------------------------------------------------------

void __fastcall TfrmZaradenie::edWheelsStateAddChange(TObject *Sender)
{
    if(StrLen(edWheelsStateAdd->Text.c_str()) == 1)
      edCoolingStateAdd->SetFocus();
}
//---------------------------------------------------------------------------

void __fastcall TfrmZaradenie::edCoolingStateAddChange(TObject *Sender)
{
    if(StrLen(edCoolingStateAdd->Text.c_str()) == 1)
      mePrislusAdd->SetFocus();
}
//---------------------------------------------------------------------------

void __fastcall TfrmZaradenie::mePrislusAddChange(TObject *Sender)
{
   if(MAXNOTE == StrLen(mePrislusAdd->Text.c_str()))
     btnAddCarOK->SetFocus();
}
//---------------------------------------------------------------------------
//   NASLEDUJE DINICIA VLASTNYCH FUNKCII POUZITYCH PRI NACITANI ZAZNAMU
//===========================================================================
int CheckOutSPZ(TEdit *edSPZAdd, TButton *Button)
{

// Kontrola spravnosti dlzky a formatu SPZ vozidla

   if(!StrLen(edSPZAdd->Text.c_str()) && Button->Focused())
      {
         ShowMessage("Nie je mon evidova vozidlo ak nezadte jeho PZ");
         edSPZAdd->SetFocus();
         return false;
      }
   if(MAXSPZ != StrLen(edSPZAdd->Text.c_str()))
      {
         ShowMessage("Nesprvna dka PZ vozidla");
         edSPZAdd->SetFocus();
         return false;
      }
   int Size = StrLen(edSPZAdd->Text.c_str());
   Size++;                                //Add room for null character
   char *Buffer = new char[Size];         //Creates Buffer dynamic variable

   edSPZAdd->GetTextBuf(Buffer,Size);  //Insert Text into the Buffer

   if( Buffer[0] < 'A' || Buffer[0] > 'Z' || Buffer[1] < 'A' || Buffer[1] > 'Z' \
      || Buffer[2] != '-' || Buffer[3]< '0' || Buffer[3] > '9' \
      || Buffer[4]< '0' || Buffer[4] > '9' || Buffer[5]< '0' || Buffer[5] > '9' \
      || Buffer[6] < 'A' || Buffer[6] > 'Z' || Buffer[7] < 'A' || Buffer[7] > 'Z')
      {
         ShowMessage("Nesprvny formt PZ vozidla");
         edSPZAdd->SetFocus();
         return false;
      }
   return true;
}
//---------------------------------------------------------------------------
int CheckOutStav(TEdit *edStav)
{
//Kotrola spravnosti hodnotenia stavu

   if(1 < StrLen(edStav->Text.c_str()))
      {
         ShowMessage("Nesprvna dka hodnotenia stavu");
         edStav->SetFocus();
         return false;
      }
   char Character;
   Character = *(edStav->Text.c_str());
   if(Character < '1' || Character > '5')
      {
         ShowMessage("Pozor! Stav asti vozidla m by hodnoten znmkou 1 a 5");
         edStav->SetFocus();
         return false;
      }
   return true;
}
//---------------------------------------------------------------------------
int CheckOutBelong(TMemo *mePrislus)
{
//Kontrola dlzky

   if(MAXNOTE < StrLen(mePrislus->Text.c_str()))
      {
         ShowMessage("Poznmka je prli dlh");
         mePrislus->SetFocus();
         return false;
      }
   return true;
}
//---------------------------------------------------------------------------


